#include<bits/stdc++.h>

#define f first
#define s second
#define vec vector
#define pb push_back
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define ld long double
#define pii pair<int, int>

using namespace std;
const int MAXN = 1e5 + 22;
const int INF = 1e9;

struct SegTree{
    vec<pii> t;

    SegTree (int m)
    {
        t.resize(4 * m);
    }

    void push(int v, int vl, int vr)
    {
        if(t[v].s)
        {
            t[v].f += t[v].s;

            if(vl != vr)
            {
                t[v * 2 + 1].s += t[v].s;
                t[v * 2 + 2].s += t[v].s;
            }

            t[v].s = 0;
        }
    }

    void update(int v, int vl, int vr, int l, int r, int x)
    {
        push(v, vl, vr);
        if(vl > r or vr < l)
            return;
        if(l <= vl and vr <= r)
        {
            t[v].s += x;
            push(v, vl, vr);
            return;
        }

        int vm = vl + vr >> 1;

        update(v * 2 + 1, vl, vm, l, r, x);
        update(v * 2 + 2, vm + 1, vr, l, r, x);

        t[v].f = min(t[v * 2 + 1].f, t[v * 2 + 2].f);
    }

    int query(int m)
    {
        push(0, 0, m - 1);
        return t[0].f;
    }
};

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n, m, q;
    cin >> n >> m >> q;

    SegTree T (m);
    long long ans = 0;

    FOR(i, q)
    {
        long long l, r;
        cin >> l >> r;
        int posl = l % m;
        int dl = l / m;
        int posr = r % m;
        int dr = r / m;

        if(dr == dl)
        {
            T.update(0, 0, m - 1, posl, posr, 1);
        }
        else if(dl + 1 == dr)
        {
            T.update(0, 0, m - 1, posl, m - 1, 1);
            T.update(0, 0, m - 1, 0, posr, 1);
        }
        else
        {
            ans += dr - dl - 1;
            T.update(0, 0, m - 1, posl, m - 1, 1);
            T.update(0, 0, m - 1, 0, posr, 1);
        }
    }

    ans += T.query(m);
    cout << ans;
}



