#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

struct Exam {
    int fl, fr;
    int sl, sr;
};

bool intersect(const std::pair<int, int>& exam, const std::pair<int, int>& tour)
{
    if (exam.first <= tour.first && tour.second <= exam.second) {
	return true;
    }
    if (tour.first <= exam.first && exam.second <= tour.first) {
	return true;
    }
    return false;
}

int main()
{
    int n, m;
    std::cin >> n >> m;
    std::vector<Exam> exams(n);
    for (Exam& exam: exams) {
	std::cin >> exam.fl >> exam.fr >> exam.sl >> exam.sr; 
    }
    std::vector<std::pair<int, int>> tours(m);
    bool group1 = true;
    for (auto& tour: tours) {
	std::cin >> tour.first >> tour.second;
	if (tour.first != tour.second) {
	    group1 = false;
	    break;
	}
    }
    if (group1) {
	int ans = 0;
	for (Exam& exam: exams) {
	    int cntf = lower_bound(tours.begin(), tours.end(), std::make_pair(exam.fr + 1, 0)) - lower_bound(tours.begin(), tours.end(), std::make_pair(exam.fl, 0));
	    int cnts = lower_bound(tours.begin(), tours.end(), std::make_pair(exam.sr + 1, 0)) - lower_bound(tours.begin(), tours.end(), std::make_pair(exam.sl, 0));
	    ans += std::min(cntf, cnts);
	}
	std::cout << m - ans << '\n';
	return 0;
    }
    int ans = 0;
    int total = 0;
    std::set<std::pair<int, int>> bad;
    for (Exam& exam: exams) {
	//int cntf = lower_bound(tours.begin(), tours.end(), std::make_pair(exam.fr + 1, 0)) - lower_bound(tours.begin(), tours.end(), std::make_pair(exam.fl, 0));
	//int cnts = lower_bound(tours.begin(), tours.end(), std::make_pair(exam.sr + 1, 0)) - lower_bound(tours.begin(), tours.end(), std::make_pair(exam.sl, 0));
	std::set<std::pair<int, int>> intersectf, intersects;
	for (auto& tour: tours) {
	    if (intersect({exam.fl, exam.fr}, tour)) {
		intersectf.insert(tour);
	    } 
	    if (intersect({exam.sl, exam.sr}, tour)) {
		intersects.insert(tour);
	    }
	}
	if (intersectf.size() < intersects.size()) {
	    for (auto& el: intersectf) {
		bad.insert(el);
	    }
	} else {
	    for (auto& el: intersects) {
		bad.insert(el);
	    }
	}
    }
    std::cout << m - bad.size() << '\n';
    
    return 0;
}

