#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

struct Exam {
    int fl, fr;
    int sl, sr;
};

bool intersect(const std::pair<int, int>& exam, const std::pair<int, int>& tour)
{
    if (exam.first <= tour.first && tour.second <= exam.second) {
	return true;
    }
    if (tour.first <= exam.first && exam.second <= tour.second) {
	return true;
    }
    if (tour.first <= exam.second && exam.second <= tour.second) {
	return true;
    }
    if (exam.first <= tour.second && tour.second <= exam.second) {
	return true;
    }
    return false;
}

int main()
{
    int n, m;
    std::cin >> n >> m;
    std::vector<Exam> exams(n);
    for (Exam& exam: exams) {
	std::cin >> exam.fl >> exam.fr >> exam.sl >> exam.sr; 
    }
    std::vector<std::pair<int, int>> tours(m);
    bool group1 = true;
    for (auto& tour: tours) {
	std::cin >> tour.first >> tour.second;
	if (tour.first != tour.second) {
	    group1 = false;
	    break;
	}
    }
    if (group1) {
	int ans = 0;
	for (Exam& exam: exams) {
	    int cntf = lower_bound(tours.begin(), tours.end(), std::make_pair(exam.fr + 1, 0)) - lower_bound(tours.begin(), tours.end(), std::make_pair(exam.fl, 0));
	    int cnts = lower_bound(tours.begin(), tours.end(), std::make_pair(exam.sr + 1, 0)) - lower_bound(tours.begin(), tours.end(), std::make_pair(exam.sl, 0));
	    ans += std::min(cntf, cnts);
	}
	std::cout << m - ans << '\n';
	return 0;
    }
    int ans = 0;
    for (int mask = 1; mask < (1 << m); ++mask) {
	std::vector<std::pair<int, int>> selected;
	for (int i = 0; i < m; ++i) {
	    if (mask & (1 << i)) {
		selected.push_back(tours[i]);
	    }
	}
	std::set<int> touched;
	bool bad = false;
	for (auto& tour: selected) {
	    if (bad) break;
	    for (int i = 0; i < n; ++i) {
		if (intersect({exams[i].fl, exams[i].fr}, tour)) {
		    if (touched.count(2*i + 1)) {
			bad = true;
			break;
		    }
		    touched.insert(2*i);
		}
		if (intersect({exams[i].sl, exams[i].sr}, tour)) {
		    if (touched.count(2*i)) {
			bad = true;
			break;
		    }
		    touched.insert(2*i + 1);
		}
	    }
	}
	if (!bad) {
	    int size = selected.size();
	    ans = std::max(ans, size); 
	}
    }
    std::cout << ans << '\n';
    
    return 0;
}

