#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 0
#endif

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

#ifdef LOCAL
int kitchen;
#endif

constexpr int N = 20 + 5;
array<vi, N> g, path;
array<int, N> dp;
int rpath[N];
int now = 0;

void dfs(int v) {
    // debug(v, now);
    path[now].push_back(v);
    rpath[v] = now;

    bool fst = true;
    for (auto u: g[v]) {
        if (rpath[u] == -1) {
            if (fst) fst = false;
            else now++;

            dfs(u);
        }
    }
}

void dfs1(int v, int p) {
    // debug(v);
    for (auto u: g[v]) {
        if (u != p) dp[u] = dp[v] + 1, dfs1(u, v);
    }
}

int ask_intern(int v) {
#ifdef LOCAL
    if (v == kitchen) return -1;

    pii ans = {-1, INT_MAX};
    for (auto u: g[v]) {
        if (ckmin(ans.second, dp[u])) ans.first = u;
    }
    return ans.first;
#else
    cout << v + 1 << endl;
	int u;
	cin >> u;

	return u - 1;
#endif
}

int ask(int v) {
    int u = ask_intern(v);
    if (u == -1) {
        cout << "! " << v + 1 << endl;
        exit(0);
    }
    return u;
}

int go(int p) {
    int lo = 0, hi = sz(path[p]);
    while (lo + 1 < hi) {
        int mid = (lo + hi) / 2;

        int ans = ask(path[p][mid]);
        if (rpath[ans] != p) return go(rpath[ans]);

        if (ans == path[p][mid + 1]) lo = mid + 1;
        else hi = mid;
    }

    int ans = ask(lo);
    if (rpath[ans] == p) return ans;
    return go(rpath[ans]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n;
    cin >> n;

    rep(i, 0, n - 1) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

#ifdef LOCAL
    cin >> kitchen;
    kitchen--;
    dfs1(kitchen, -1);
#endif

    memset(rpath, -1, sizeof(rpath));
    dfs(0);

    cout << go(0) << endl;
}