#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

using T = long double;

int sgn(T a) { return (a > 0) - (a < 0); }

T sq(T a) { return a * a; }

struct P {
    T x, y;

    P() = default;

    P(T x, T y) : x(x), y(y) {}
};

using vP = vector<P>;

P operator+(P l, P r) { return P(l.x + r.x, l.y + r.y); }
P operator-(P l, P r) { return P(l.x - r.x, l.y - r.y); }
P operator*(P l, T r) { return P(l.x * r, l.y * r); }
P operator/(P l, T r) { return P(l.x / r, l.y / r); }
T dot(P a, P b) { return a.x * b.x + a.y * b.y; }
T cross(P a, P b) { return a.x * b.y - a.y * b.x; }
T cross(P p, P a, P b) { return cross(a - p, b - p); }

bool onSeg(P p, P a, P b) {
    return cross(a, b, p) == 0 && dot(p - a, p - b) <= 0;
}

string inPoly(const vP& p, P z) {
    int n = sz(p), ans = 0;
    rep(i, 0, n) {
        P x = p[i], y = p[(i + 1) % n];
        if (onSeg(z, x, y)) return "on";
        if (x.y > y.y) swap(x, y);
        if (x.y <= z.y && y.y > z.y && cross(z, x, y) > 0) ans ^= 1;
    }
    return ans ? "in" : "out";
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n;
    cin >> n;
    vP p(n);

    rep(i, 0, n) {
        cin >> p[i].x >> p[i].y;
    }

    int ans = 0;
    rep(i, 1, 1001) {
        rep(j, 1, 1001) {
            if (gcd(i, j) == 1) ans += inPoly(p, P(i, j)) != "out";
        }
    }

    cout << ans << '\n';
}