#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

using T = long double;

int sgn(T a) { return (a > 0) - (a < 0); }

T sq(T a) { return a * a; }

struct P {
    T x, y;

    P() = default;
    P(T x, T y) : x(x), y(y) {}
    bool operator<(const P& rhs) const {
        if (x != rhs.x)
            return x < rhs.x;
        return y < rhs.y;
    }
    bool operator==(const P& rhs) const {
        return x == rhs.x &&
               y == rhs.y;
    }
    bool operator!=(const P& rhs) const {
        return !(rhs == *this);
    }
};

using vP = vector<P>;

P operator+(P l, P r) { return P(l.x + r.x, l.y + r.y); }
P operator-(P l, P r) { return P(l.x - r.x, l.y - r.y); }
P operator*(P l, T r) { return P(l.x * r, l.y * r); }
P operator/(P l, T r) { return P(l.x / r, l.y / r); }
T dot(P a, P b) { return a.x * b.x + a.y * b.y; }
T cross(P a, P b) { return a.x * b.y - a.y * b.x; }
T cross(P p, P a, P b) { return cross(a - p, b - p); }

bool onSeg(P p, P a, P b) {
    return cross(a, b, p) == 0 && dot(p - a, p - b) <= 0;
}

pair<vi, vi> ulHull(const vP& P) {
    vi p(sz(P)), u, l;
    iota(all(p), 0);
    sort(all(p), [&P](int a, int b) { return P[a] < P[b]; });

    for (auto& i: p) {
#define ADDP(C, cmp) while (sz(C) > 1 && cross(P[C[sz(C) - 2]], P[C.back()], P[i]) cmp 0) \
    C.pop_back(); C.push_back(i)
        ADDP(u, >=);
        ADDP(l, <=);
    }
    return {u, l};
}

vi hullInd(const vP& P) {
    vi u, l;
    tie(u, l) = ulHull(P);
    if (sz(l) <= 1) return l;
    if (P[l[0]] == P[l[1]]) return {0};
    l.insert(end(l), 1 + rbegin(u), rend(u) - 1);
    return l;
}

vP hull(const vP& P) {
    vi v = hullInd(P);
    vP res;
    for (auto en: v) res.push_back(P[en]);
    return res;
}

bool inAngle(P a, P o, P c, P p) {
    if (cross(o, a, c) > 0) swap(a, c);
    return cross(o, c, p) >= 0 && cross(o, a, p) <= 0;
}

bool inPoly(const vP& p, P z) {
    int lo = 1, hi = sz(p) - 1;
    while (lo + 1 < hi) {
        int mid = (lo + hi) / 2;
        if (inAngle(p[hi], p[0], p[mid], z)) lo = mid;
        else hi = mid;
    }

    return inAngle(p[hi], p[0], p[lo], z) && inAngle(p[0], p[hi], p[lo], z);
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n;
    cin >> n;
    vP p(n);

    rep(i, 0, n) {
        cin >> p[i].x >> p[i].y;
    }

    p = hull(p);
    n = sz(p);

    int ans = 0;
    rep(i, 1, 10001) {
        rep(j, 1, 10001) {
            if (gcd(i, j) == 1) ans += inPoly(p, P(i, j));
        }
    }

    cout << ans << '\n';
}