#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 0
#endif

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

struct node {
    int val{}, d{}, l{}, r{};
    node* ch[2] = {nullptr, nullptr};

    node(int val, int d, int l, int r) : val(val), d(d), l(l), r(r) {}
};

node* go(node* t, int id) {
    if (t->ch[id] == nullptr) {
        int mid = (t->l + t->r) / 2;
        t->ch[id] = new node(0, 0, id ? mid : t->l, id ? t->r : mid);
    }

    return t->ch[id];
}

void apply(node* v, int value) {
    v->val += value;
    if (v->r - v->l > 1) v->d += value;
}

void push(node* v) {
    if (v->d == 0) return;

    apply(go(v, 0), v->d);
    apply(go(v, 1), v->d);
    v->d = 0;
}

void update(node* v, int l, int r, int value) {
    push(v);
    if (max(l, v->l) >= min(r, v->r)) return;

    if (l <= v->l && v->r <= r) {
        apply(v, value);
        return;
    }

    update(go(v, 0), l, r, value);
    update(go(v, 1), l, r, value);
    v->val = min(go(v, 0)->val, go(v, 1)->val);
}

int query(node* v, int l, int r) {
    push(v);
    if (max(l, v->l) >= min(r, v->r)) return INT_MAX;

    if (l <= v->l && v->r <= r) {
        return v->val;
    }

    return min(query(go(v, 0), l, r), query(go(v, 1), l, r));
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n, m, q;
    cin >> n >> m >> q;

    node* root = new node(0, 0, 0, m);
    while (q--) {
        ll l, r;
        cin >> l >> r;
        --l;

        int cnt = (r - l) / m;
        l += 1LL * cnt * m;

        update(root, 0, m, cnt);

        int ql = l % m, qr = r % m;
        if (ql > qr) {
            update(root, ql, m, 1);
            update(root, 0, qr, 1);
        } else update(root, ql, qr, 1);
    }

    cout << query(root, 0, m) << '\n';
}