/*
Привет!

Завтра состоится заключительный этап Вузовско-академической олимпиады по информатике 2022.

Для дистанционных участников тур будет проводиться с помощью прокторинга. Мы подготовили страницу с основными правилами, просим внимательно ознакомиться с ней:
https://sp.urfu.ru/vuzakadem/inform/2022/proctoring.html

В 11:00 по времени Екатеринбурга (МСК+2) откроется пробный тур, принимать участие в нем нужно без прокторинга.
Ссылка для входа в тур: 
https://official.contest.yandex.ru/contest/36501

В 12:00 по времени Екатеринбурга (МСК+2) начнется основной тур. Чтобы открыть его, воспользуйся уникальной ссылкой за 15 минут до начала тура:
https://integration.examus.net/kontur/start/efce182e-3ef0-4ba8-b52d-94660250019b/
❗Внимание: ссылку не нужно нажимать заранее.

Данные для входа в систему (совпадают для пробного и основного туров):

Логин: vuzak2022-final-56
Пароль: FFxwggWLnr

По всем вопросам нам можно написать в этом чате или по почте sp@urfu.ru.
*/

/* void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<ll>> days(n);
    fi(n) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        days[i] = {a, b, c, d};
    }
    vector<vector<ll>> free(m);
    fi(m) {
        ll a, b;
        cin >> a >> b;
        free[i] = {a, b};
    }
} */

#include <bits/stdc++.h>

using namespace std;

#define fi(n) for (int i = 0; i < n; i++)
#define all(ls) ls.begin(), ls.end()

typedef long long ll;
typedef vector<ll> vi;

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

vi factorization(ll n) {
    ll i = 1;
    vi ans;
    while (i * i <= n) {
        if (n % i == 0) {
            ans.push_back(i);
            ans.push_back(n / i);
        }
        i++;
    }
    sort(all(ans));
    return ans;
}

void solve() {
    ll a, b;
    cin >> a >> b;
    vi fact1 = factorization(a), fact2 = factorization(b);
    if (a == b || fact1[fact1.size() - 2] == b || fact2[fact2.size() - 2] == a) {
        cout << min(a, b) << '\n';
        return;
    }
    while (true) {
        if (gcd(a, b) == 1) {
            cout << 1 << '\n';
            return;
        }
        ll min_ans = min(a, b);
        vi fact1 = factorization(a), fact2 = factorization(b);
        if (fact1[fact1.size() - 2] == b || fact2[fact2.size() - 2] == a) {
            cout << min_ans << '\n';
            return;
        }
        if (a >= b) {
            a = fact1[fact1.size() - 2];
        } else {
            b = fact2[fact2.size() - 2];
        }
    }

}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t; cin >> t;
    fi(t) {
        solve();
        cout.flush();
    }
}