#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <bitset>
#include <iomanip>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>

#include <ext/pb_ds/assoc_container.hpp> // РћР±С‰РёР№ С„Р°Р№Р».
#include <ext/pb_ds/tree_policy.hpp> // РЎРѕРґРµСЂР¶РёС‚ РєР»Р°СЃСЃ tree_order_statistics_node_update

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,fma,tune=native")

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int int_fast32_t
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(x, y) cout << #x << " = " << x << ' ' << #y << " = " << y << endl;
#define trace3(x, y, z) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << endl;
#define trace4(x, y, z, a) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << ' ' << #a << " = " << a << endl;
#define trace_name(x) cout << #x << " = ";
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

mt19937 rnd(time(0));

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);  // 998244353; //
const ld EPS = (ld)(1e-10);
const ld PI = acos(-1);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

template <typename T>
using ordered_set =  tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

const ll MAXN = 2e5 + 2;
vector<ll> g[MAXN];
ll used[MAXN];
ll sz[MAXN];

void dfs(ll v, ll p) {
    sz[v] = 1;
    for (auto i : g[v]) {
        if (i == p || used[i]) continue;

        dfs(i, v);
        sz[v] += sz[i];
    }
}

ll find_centroid(ll v, ll p, ll all_sz) {
    for (auto i : g[v]) {
        if (!used[i] && i != p && sz[i] > all_sz / 2) return find_centroid(i, v, all_sz);
    }

    return v;
}

void go(ll v) {
    dfs(v, -1);
    ll centr = find_centroid(v, -1, sz[v]);

    cout << centr + 1 << endl;

    ll x;
    cin >> x;

    if (!x) {
        cout << "! " << centr + 1;
        exit(0);
    }

    used[centr] = 1;
    go(x - 1);
}

void solve() {
    ll n;
    cin >> n;

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;

        --a, --b;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    go(0);
}

signed main() {
//    freopen("mountain.in", "r", stdin);
//    freopen("mountain.out", "w", stdout);

    fast_stream();

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}

/*

0 1
0 0
1 0
0 -1

*/