#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <bitset>
#include <iomanip>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>

#include <ext/pb_ds/assoc_container.hpp> // РћР±С‰РёР№ С„Р°Р№Р».
#include <ext/pb_ds/tree_policy.hpp> // РЎРѕРґРµСЂР¶РёС‚ РєР»Р°СЃСЃ tree_order_statistics_node_update

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,fma,tune=native")

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int int_fast32_t
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(x, y) cout << #x << " = " << x << ' ' << #y << " = " << y << endl;
#define trace3(x, y, z) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << endl;
#define trace4(x, y, z, a) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << ' ' << #a << " = " << a << endl;
#define trace_name(x) cout << #x << " = ";
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

mt19937 rnd(time(0));

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);  // 998244353; //
const ld EPS = (ld)(1e-10);
const ld PI = acos(-1);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

template <typename T>
using ordered_set =  tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

const int P = 97, K = 20;
ll step_p[K];

void precalc() {
    step_p[0] = 1;

    for (int i = 1; i < K; ++i) {
        step_p[i] = step_p[i - 1] * P;
        step_p[i] %= MOD;
    }
}

void solve() {
    precalc();

    int n, k, a;
    cin >> n >> k >> a;

    string alph;
    cin >> alph;

    map<char, int> pos_char;
    for (int i = 0; i < a; ++i) {
        pos_char[alph[i]] = i + 1;
    }

    vector<string> rt(n);
    map<pair<ll, ll>, int> cnt_in_strings;
    vector<vector<ll>> hash_on_pref(n, vector<ll> (k + 1));
    for (int i = 0; i < n; ++i) {
        cin >> rt[i];

        hash_on_pref[i][0] = 0;
        for (int j = 0; j < k; ++j) {
            hash_on_pref[i][j + 1] = hash_on_pref[i][j] * P;
            hash_on_pref[i][j + 1] %= MOD;
            hash_on_pref[i][j + 1] += pos_char[rt[i][j]];
            hash_on_pref[i][j + 1] %= MOD;
        }

        for (int j = 0; j < k; ++j) {
            ll fir_hash = hash_on_pref[i][j] - hash_on_pref[i][0];
            ll sec_hash = hash_on_pref[i][k] - (hash_on_pref[i][j + 1] * step_p[k - j - 1]) % MOD;
            if (sec_hash < 0) sec_hash += MOD;
            sec_hash %= MOD;
            cnt_in_strings[{fir_hash, sec_hash}]++;
        }
    }

    for (int i = 0; i < n; ++i) {
        string to_ans = "-1";
        int ans = 0;

        bool flag = true;
        for (int j = 0; j < k; ++j) {
            ll fir_hash = hash_on_pref[i][j] - hash_on_pref[i][0];
            ll sec_hash = hash_on_pref[i][k] - (hash_on_pref[i][j + 1] * step_p[k - j - 1]) % MOD;
            if (sec_hash < 0) sec_hash += MOD;
            sec_hash %= MOD;
            // cnt_in_strings[{fir_hash, sec_hash}]++;

            // cout << cnt_in_strings[{fir_hash, sec_hash}] << endl;
            if (cnt_in_strings[{fir_hash, sec_hash}] >= 2) {
                flag = false;
                break;
            }
        }

        if (flag) {
            ++ans;
            to_ans = rt[i];
        }

        for (int j = 0; j < k; ++j) { // MAKE J = 0
            for (int h = 0; h < a; ++h) { // MAKE H = 0
                if (rt[i][j] == alph[h]) continue;
                string now = rt[i];
                now[j] = alph[h];

                vector<ll> hash(k + 1);

                hash[0] = 0;
                for (int jj = 0; jj < k; ++jj) {
                    hash[jj + 1] = hash[jj] * P;
                    hash[jj + 1] %= MOD;
                    hash[jj + 1] += pos_char[now[jj]];
                    hash[jj + 1] %= MOD;
                }

                flag = true;
                for (int q = 0; q < k; ++q) {
                    ll fir_hash = hash[q] - hash[0];
                    ll sec_hash = hash[k] - (hash[q + 1] * step_p[k - q - 1]) % MOD;
                    if (sec_hash < 0) sec_hash += MOD;
                    sec_hash %= MOD;

                    if (cnt_in_strings[{fir_hash, sec_hash}] >= 1 + (q == j)) {
                        flag = false;
                        break;
                    }
                }

                if (flag) {
                    ++ans;
                    if (ans == 1) to_ans = now;
                }
            }

            // cout << i << ' ' << j << ' ' << ans << '\n';
        }
        // cout << endl;

        cout << ans;
        if (ans) cout << ' ' << to_ans;
        cout << '\n';
    }
}

signed main() {
//    freopen("mountain.in", "r", stdin);
//    freopen("mountain.out", "w", stdout);

    fast_stream();

    int tests = 1;
//    cin >> tests;
    while (tests--) {
        solve();
    }
}

/*

0 1
0 0
1 0
0 -1

*/