//#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
}

const int N = 6e5;
long long val[N * 4];

void update(int l, int r, int i, int cutl, int cutr, long long x) {
	if (l == cutl && r == cutr) {
		val[i] += x;
		return;
	}
	int mid = (l + r) >> 1;
	if (cutl <= mid)
		update(l, mid, i * 2, cutl, min(cutr, mid), x);
	if (cutr > mid)
		update(mid + 1, r, i * 2 + 1, max(cutl, mid + 1), cutr, x);
}

long long get(int l, int r, int i, int pos) {
	if (l == r)
		return val[i];
	int mid = (l + r) >> 1;
	long long res = val[i];
	if (pos <= mid)
		res += get(l, mid, i * 2, pos);
	else
		res += get(mid + 1, r, i * 2 + 1, pos);
	return res;
}

int main() {
	start();
	long long n, m, q;
	long long ans = 1e18;
	unordered_map<long long, int> pos;
	vector<long long> vp;
	vector<pair<long long, long long>> t;
	cin >> n >> m >> q;
	vp.push_back(0);
	vp.push_back(m - 1);
	for (int i = 0; i < q; i++) {
		long long l, r;
		cin >> l >> r;
		l--, r--;
		vp.push_back(l % m);
		vp.push_back(r % m);
		t.push_back({ l, r});
	}
	sort(vp.begin(), vp.end());
	for (int i = vp.size() - 1; i > 0; i--)
		vp.push_back((vp[i] + vp[i - 1]) >> 1);
	sort(vp.begin(), vp.end());
	pos[vp[0]] = 0;
	for (int i = 1; i < vp.size(); i++)
		if(vp[i] != vp[i - 1])
			pos[vp[i]] = pos.size();
	for (auto i : t) {
		long long h1 = i.first / m, h2 = i.second / m;
		long long l = i.first % m, r = i.second % m;
		if (h1 == h2)
			update(0, pos.size() - 1, 1, pos[l], pos[r], 1);
		else {
			update(0, pos.size() - 1, 1, pos[l], pos.size() - 1, 1);
			update(0, pos.size() - 1, 1, 0, pos.size() - 1, h2 - h1 - 1);
			update(0, pos.size() - 1, 1, 0, pos[r], 1);
		}
	}
	for (int i = 0; i < vp.size(); i++)
		ans = min(ans, get(0, pos.size() - 1, 1, pos[vp[i]]));
	cout << ans;
	return 0;
}