#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <stack>
#include <fstream>
#include <algorithm>
#include <queue>
#include <cmath>
#include <iomanip>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
ll mod = 998244353;
long long p = 239, p1 = 911, mod1 = (1e+9) + 7, INF = 1e18;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

ll binpow(ll a, ll x) {
    if (a == 1 || x == 0) return 1;
    if (x == 1) return a;
    if (x & 1)
        return binpow(a, x - 1) * a % mod1;
    else {
        ll temp = binpow(a, x >> 1);
        return temp * temp % mod1;
    }
}

struct node {
    ll l, r, val, push, ind;
};

struct edge {
    ll x, y1, y2, openfl;
};

const ll N = (1e6) * 2 + 1;
vector<node> tree;

void push(ll v) {
    tree[v].val += tree[v].push;
    if (tree[v].r - tree[v].l != 1) {
        tree[2 * v].push += tree[v].push;
        tree[2 * v + 1].push += tree[v].push;
    }
    tree[v].push = 0;
}

void build(ll v, ll l, ll r) {
    if (r - l == 1) {
        tree[v] = {l, r, 0, 0, l};
        return;
    }
    ll m = l + (r - l) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m, r);
    tree[v] = {l, r, max(tree[2 * v + 1].val, tree[2 * v].val), 0, l};
}

void update(ll v, ll l, ll r, ll val) {
    push(v);
    if (tree[v].r <= l || tree[v].l >= r) return;
    if (tree[v].l >= l && tree[v].r <= r) {
        tree[v].push += val;
        push(v);
        return;
    }
    update(2 * v, l, r, val);
    update(2 * v + 1, l, r, val);
    if (tree[2 * v].val >= tree[2 * v + 1].val) tree[v].ind = tree[2 * v].ind;
    else tree[v].ind = tree[2 * v + 1].ind;
    tree[v].val = max(tree[2 * v].val, tree[2 * v + 1].val);
}

pair<ll, ll> get(ll v, ll l, ll r) {
    push(v);
    if (tree[v].r <= l || tree[v].l >= r) return {-INF, -1};
    if (tree[v].r <= r && tree[v].l >= l) return {tree[v].val, tree[v].ind};
    pair<ll, ll> fr = get(v * 2, l, r), sc = get(2 * v + 1, l, r);
    if (fr.first > sc.first) return fr;
    else return sc;
}

struct cnt{
    ll l = 0, r = 0, next = 0;
};


vector<vector<ll >> g;
ll st = -1, mx = -1;
vector < ll > h, pred;
vector < bool > used;

void dfs(ll v) {
    used[v] = true;
    if (h[v] > mx) {
        mx = h[v];
        st = v;
    }
    for (auto u: g[v]) {
        if (!used[u]) {
            h[u] = h[v] + 1;
            pred[u] = v;
            dfs(u);
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector < ll > a, b;
    for (ll i = 2; i * i <= n; i++) {
        while (n % i == 0) {
            a.push_back(i);
            n /= i;
        }
    }
    if (n != 1) a.push_back(n);
    for (ll i = 2; i * i <= m; i++) {
        while (m % i == 0) {
            b.push_back(i);
            m /= i;
        }
    }
    if (m != 1) b.push_back(m);
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
//    for (auto i: a) cout << i << ' ';
//    cout << '\n';
//    for (auto i: b) cout << i << ' ';
//    cout << '\n';
    ll i = 0, j = 0, res = 1;
    while (i < a.size() && j < b.size() && a[i] == b[j]) {
        res *= a[i];
        i++;
        j++;
    }
    cout << res << endl;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}