#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;

struct segtree {
    static const int size = 256 * 1024;

    struct node {
        int val = 0;
        int push = 0;
    };

    node tree[size * 2 - 1]{};

    void push(int x) {
        tree[x * 2 + 1].val += tree[x].push;
        tree[x * 2 + 1].push += tree[x].push;

        tree[x * 2 + 2].val += tree[x].push;
        tree[x * 2 + 2].push += tree[x].push;

        tree[x].push = 0;
    }

    void add(int l, int r, int val, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            tree[x].val += val;
            tree[x].push += val;
            return;
        }

        if (l >= rx || lx >= r) {
            return;
        }

        push(x);
        add(l, r, val, x * 2 + 1, lx, (lx + rx) / 2);
        add(l, r, val, x * 2 + 2, (lx + rx) / 2, rx);
        tree[x].val = std::min(tree[x * 2 + 1].val, tree[x * 2 + 2].val);
    }

    int min(int l, int r, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            return tree[x].val;
        }
        if (l >= rx || lx >= r) {
            return LLONG_MAX;
        }
        push(x);
        return std::min(min(l, r, x * 2 + 1, lx, (lx + rx) / 2), min(l, r, x * 2 + 2, (lx + rx) / 2, rx));
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, q; cin >> n >> m >> q;

    segtree A;
    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r;
        if (r - l + 1 >= m) {
            A.add(0, m, (r - l + 1) / m);
        }
        int len = (r - l + 1) % m;
        if (len == 0) continue;
        r = l + len - 1;
        l = (l - 1 + m) % m;
        r = (r - 1 + m) % m;

        if (l <= r) {
            A.add(l, r + 1, 1);
        }
        else {
            A.add(l, m, 1);
            A.add(0, r + 1, 1);
        }
    }
    cout << A.min(0, m);
    return 0;
}