#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;

struct node {
    int val = 0;
    int push = 0;
    node *left = nullptr;
    node *right = nullptr;
};

void push(node* x) {
    if (x->left == nullptr) x->left = new node;
    x->left->val += x->push;
    x->left->push += x->push;

    if (x->right == nullptr) x->right = new node;
    x->right->val += x->push;
    x->right->push += x->push;

    x->push = 0;
}

void add(int l, int r, int val, node *x, int lx = 0, int rx = 2e9) {
    if (l <= lx && rx <= r) {
        x->val += val;
        x->push += val;
        return;
    }
    if (l >= rx || lx >= r) {
        return;
    }
    push(x);
    add(l, r, val, x->left, lx, (lx + rx) / 2);
    add(l, r, val, x->right, (lx + rx) / 2, rx);
    x->val = min(x->left->val, x->right->val);
}

int get_min(int l, int r, node *x, int lx = 0, int rx = 2e9) {
    if (l <= lx && rx <= r) {
        return x->val;
    }
    if (l >= rx || lx >= r) {
        return INT32_MAX;
    }
    push(x);
    return min(
            get_min(l, r, x->left, lx, (lx + rx) / 2),
            get_min(l, r, x->right, (lx + rx) / 2, rx)
            );
}

struct segtree {
    static const int size = 256 * 1024;

    struct node {
        int val = 0;
        int push = 0;
    };

    node tree[size * 2 - 1]{};

    void push(int x) {
        tree[x * 2 + 1].val += tree[x].push;
        tree[x * 2 + 1].push += tree[x].push;

        tree[x * 2 + 2].val += tree[x].push;
        tree[x * 2 + 2].push += tree[x].push;

        tree[x].push = 0;
    }

    void add(int l, int r, int val, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            tree[x].val += val;
            tree[x].push += val;
            return;
        }

        if (l >= rx || lx >= r) {
            return;
        }

        push(x);
        add(l, r, val, x * 2 + 1, lx, (lx + rx) / 2);
        add(l, r, val, x * 2 + 2, (lx + rx) / 2, rx);
        tree[x].val = std::min(tree[x * 2 + 1].val, tree[x * 2 + 2].val);
    }

    int min(int l, int r, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            return tree[x].val;
        }
        if (l >= rx || lx >= r) {
            return LLONG_MAX;
        }
        push(x);
        return std::min(min(l, r, x * 2 + 1, lx, (lx + rx) / 2), min(l, r, x * 2 + 2, (lx + rx) / 2, rx));
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, q; cin >> n >> m >> q;

//    segtree A;
    node* root = new node;
    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r;
        if (r - l + 1 >= m) {
            add(0, m, (r - l + 1) / m, root);
        }
        int len = (r - l + 1) % m;
        if (len == 0) continue;
        r = l + len - 1;
        l = (l - 1 + m) % m;
        r = (r - 1 + m) % m;

        if (l <= r) {
            add(l, r + 1, 1, root);
        }
        else {
            add(l, m, 1, root);
            add(0, r + 1, 1, root);
        }
    }
    cout << get_min(0, m, root);
    return 0;
}