#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

vector<bool> ok;
vector<vector<ll>> g;
vector<ll> dp;
ll mn, mnv;
ll k;

void dfs1(ll v, ll p) {
	dp[v] = 1;
	for (ll i : g[v]) {
		if (i != p && ok[i]) {
			dfs1(i, v);
			dp[v] += dp[i];
		}
	}
}

void dfs2(ll v, ll p) {
	ll mxl = k - dp[v];
	for (ll i : g[v]) {
		if (i != p && ok[i]) {
			dfs2(i, v);
			mxl = max(mxl, dp[i]);
		}
	}
	if (mxl < mn) {
		mn = mxl;
		mnv = v;
	}
}

ll get(ll v) {
	cout << v << "\n";
	cout.flush();
	ll x;
	cin >> x;
	if (x == 0) {
		cout << "! " << v << "\n";
		cout.flush();
		exit(0);
	}
	return x;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	ok.assign(n + 1, 1);
	g.resize(n + 1);
	dp.assign(n + 1, 0);
	for (ll i = 0; i < n - 1; i++) {
		ll u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	k = n;
	ll v = 1;
	while (k > 0) {
		mn = INF, mnv = v;
		dfs1(v, 0);
		dfs2(v, 0);
		v = get(mnv);
		ok[mnv] = 0;
		k = 0;
		for (ll i = 1; i <= n; i++) k += ok[i];
	}
	return 0;
}