#define _GLIBCXX_DEBUG

#include "iostream"
#include "vector"
#include "cassert"
#include "cmath"
#include "set"
#include "map"
#include "numeric"
#include "random"
#include "ctime"

#define check(x) cerr << (#x) << " = " << x << "\n"
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple

using namespace std;

using ll = long long;

const int N = (int)1e6 + 7;
const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 117;
const ll INFll = (ll)1e12 + 117;

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> inline void print(T* ar, int size_of_ar) {
    for (int i = 0; i < size_of_ar; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}

int solve();

signed main() {
//#ifdef __WIN64__
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
//#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(34);
	int t = 1;
	cin >> t;
	while (t--) assert(!solve());
}

vector<int> fact(int n) {
    vector<int> res;
    for (int d = 2; (ll)d * d <= n; ++d) {
        while (n % d == 0) {
            n /= d;
            res.push_back(d);
        }
    }
    if (n > 1) res.push_back(n);
    return res;
}

int solve() {
    int a, b;
    cin >> a >> b;
    auto fa = fact(a), fb = fact(b);

    int res = 1;

    for (int i = fa.size() - 1, j = fb.size() - 1; i >= 0 && j >= 0; --i, --j) {
        if (fa[i] != fb[j]) break;
        res *= fa[i];
    }

    cout << res << "\n";

	return 0;
}
