//#define _GLIBCXX_DEBUG

#include "iostream"
#include "vector"
#include "cassert"
#include "cmath"
#include "set"
#include "map"
#include "numeric"
#include "random"
#include "ctime"

#define check(x) cerr << (#x) << " = " << x << "\n"
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple

using namespace std;

using ll = long long;

const int N = (int)1e6 + 7;
const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 117;
const ll INFll = (ll)1e12 + 117;

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> inline void print(T* ar, int size_of_ar) {
    for (int i = 0; i < size_of_ar; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}

int solve();

signed main() {
//#ifdef __WIN64__
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
//#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(34);
	int t = 1;
	//cin >> t;
	while (t--) assert(!solve());
}

int sz = 1;
int t[N]{}, prom[N]{};

inline void inv(int v) {
    t[v] = min(t[v << 1], t[v << 1 | 1]);
}

inline void init(int n) {
    while (sz < n) sz <<= 1;
    fill(t, t + N, INF);
    fill(t + sz, t + sz + n, 0);
    for (int v = sz - 1; v > 0; --v) inv(v);
}

void push(int v, int l, int r) {
    t[v] += prom[v];
    if (r - l > 1) {
        prom[v << 1] += prom[v];
        prom[v << 1 | 1] += prom[v];
    }
    prom[v] = 0;
}

void upd(int lq, int rq, int x, int v, int l, int r) {
    push(v, l, r);
    if (l >= rq || r <= lq) return;
    if (lq <= l && r <= rq) {
        prom[v] += x;
        push(v, l, r);
        return;
    }
    int m = (l + r) / 2;
    upd(lq, rq, x, v << 1, l, m);
    upd(lq, rq, x, v << 1 | 1, m, r);
    inv(v);
}

int get(int lq, int rq, int v, int l, int r) {
    push(v, l, r);
    if (l >= rq || r <= lq) return INF;
    if (lq <= l && r <= rq) {
        return t[v];
    }
    int m = (l + r) / 2;
    return min(get(lq, rq, v << 1, l, m),  get(lq, rq, v << 1 | 1, m, r));
}

int solve() {
    int n, m, q;
    cin >> n >> m >> q;

    init(m);

    while (q--) {
        int l, r;
        cin >> l >> r;

        int a = (l - 1) % m, b = (r  - 1) % m;
        //check(a);
        //check(b);



        if (r - l + 1 < m && a <= b) {
            upd(a, b + 1, 1, 1, 0, sz);
            //check("upd 1");
        } else {
            if (a > 0) {
                upd(a, m, 1, 1, 0, sz);
                l += m - a;
            }
            if (b < m - 1) {
                upd(0, b + 1, 1, 1, 0, sz);
                r -= m - b;
            }
            //check(l);
            //check(r);
            upd(0, m, (r - l + 1) / m, 1, 0, sz);
        }

        //print(t, sz + 1);
    }

    //print(t, sz + 1);

    cout << min(n, get(0, m, 1, 0, sz)) << "\n";
	return 0;
}
