#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

// #define int ll

vector<vector<int>> graph, graph1;
vector<int> sz;
vector<bool> used;
vector<int> pr;

void dfs_sz(int v, int p = -1) {
	sz[v] = 1;
	for (auto to : graph[v]) {
		if (to != p && !used[to]) {
			dfs_sz(to, v);
			sz[v] += sz[to];
		}
	}
}

int find_centroid(int v, int n, int p = -1) {
	for (auto to : graph[v]) {
		if (to != p && !used[to] && sz[to] > n - sz[to]) {
			return find_centroid(to, n, v);
		}
	}
	return v;
}


void build(int v, int p = -1) {
	dfs_sz(v);
	int k = find_centroid(v, sz[v]);
	if (p != -1) {
		graph1[p].push_back(k);
	}
	pr[k] = p;
	used[k] = true;
	for (auto to : graph[k]) {
		if (!used[to]) {
			build(to, k);
		}
	}
}

signed main() {
#ifdef DEBUG
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	// devochka iz pitera
	int n;
	cin >> n;
	graph.resize(n);
	sz.resize(n);
	used.resize(n);
	graph1.resize(n);
	pr.resize(n);
	for (int i = 0; i + 1 < n; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}
	build(0);
	int root = find(pr.begin(), pr.end(), -1) - pr.begin();
	while (true) {
		cout << root + 1 << endl;
		int v;
		cin >> v;
		if (v == 0) {
			cout << '!' << ' ' << root + 1 << endl;
			return 0;
		}
		v--;
		int last = v;
		int p = v;
		while (p != root) {
			last = p;
			p = pr[p];
		}
		root = last;
	}
	return 0;
}