#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

int n;
vector <int> g[200010];
bool used[200010];
int was[200010];
int C = 1;

pair <int, int> dfs(int u, int d)
{
	if (used[u]) return { 0, 0 };
	if (was[u] == C) return { 0, 0 };

	was[u] = C;

	pair <int, int> ans = { d, u };
	for (auto v : g[u])
	{
		ans = max(ans, dfs(v, d + 1));
	}
	return ans;
}

int s = 1;
vector <int> path;

bool fnd(int u, int t)
{
	if (used[u]) return false;
	if (was[u] == C) return false;
	path.push_back(u);
	if (u == t) return true;
	for (auto v : g[u])
	{
		if (fnd(v, t)) return true;
	}
	path.pop_back();
	return false;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n - 1; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	while (true)
	{
		++C;
		auto g1 = dfs(s, 1);
		++C;
		auto g2 = dfs(g1.second, 1);

		path.clear();
		++C;
		fnd(g2.second, g1.second);

		int q = path[path.size() / 2];
		cout << q << endl;
		int gt;
		cin >> gt;
		if (gt == 0)
		{
			cout << "! " << q << endl;
			return 0;
		}
		used[q] = true;
		s = gt;
	}

	return 0;
}