#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

int n;
vector <int> g[200010];
int s = 1;
int used[200010];
int d[200010];

void dfs(int u, int p)
{
	d[u] = 1;
	for (auto v : g[u])
	{
		if (used[v] || v == p) continue;
		dfs(v, u);
		d[u] += d[v];
	}
}

int fnd(int u, int p, int sz)
{
	for (auto v : g[u])
	{
		if (used[v] || v == p) continue;
		if (d[v] > sz) return fnd(v, u, sz);
	}
	return u;
}


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n - 1; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	int sz = n;

	for (int _ = 0; _ < 20; ++_)
	{
		dfs(s, s);

		int q = fnd(s, s, sz / 2);

		cout << q << endl;
		int gt;
		cin >> gt;
		if (!gt)
		{
			cout << "! " << q << endl;
			return 0;
		}
		used[q] = true;
		s = gt;
		sz /= 2;
	}

	assert(false);

	return 0;
}