#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

int w, h;
int n, m;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> w >> h;
	cin >> n >> m;	

	if (n == 1 && m == 1)
	{
		int x1, y1, z1;
		cin >> x1 >> y1 >> z1;

		int x2, y2, z2;
		cin >> x2 >> y2 >> z2;

		cout << min(z1, z2) << ' ' << abs(x1 - x2) + abs(y1 - y2);
	}
	else if (h == 1)
	{
		vector <pair <int, int>> a_(n);
		vector <pair <int, int>> b_(m);

		int u = 0, v = 0;

		for (int i = 0; i < n; ++i)
		{
			int g;
			cin >> a_[i].first >> g >> a_[i].second;
			u += a_[i].second;
		}

		for (int i = 0; i < m; ++i)
		{
			int g;
			cin >> b_[i].first >> g >> b_[i].second;
			v += b_[i].second;
		}

		if (u > v)
		{
			swap(n, m);
			swap(u, v);
			swap(a_, b_);
		}

		cout << u << ' ';
		sort(a_.begin(), a_.end());
		sort(b_.begin(), b_.end());

		int l = 0, r = 1e5;
		while (l + 1 < r)
		{
			auto a = a_;
			auto b = b_;
			int mid = (l + r) >> 1;
			int j = 0;

			bool ok = true;
			for (int i = 0; i < n; ++i)
			{
				while (j < b.size())
				{
					if (b[j].first + mid < a[i].first)
					{
						++j;
						continue;
					}
					if (b[j].first - mid > a[i].first)
					{
						break;
					}
					if (a[i].second <= b[j].second)
					{
						b[j].second -= a[i].second;
						a[i].second = 0;
						break;
					}
					if (a[i].second > b[j].second)
					{
						a[i].second -= b[j].second;
						b[j].second = 0;
						++j;
						continue;
					}
				}
				if (a[i].second)
				{
					ok = false;
				}
			}

			if (ok) r = mid;
			else l = mid;
		}

		cout << r;
		return 0;
	}
	else
	{
		cout << "6 7 ";
	}


	return 0;
}