#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Exam2 {
    int l1, r1, l2, r2;

    Exam2() {}

    Exam2(int l1, int r1, int l2, int r2) : l1(l1), r1(r1), l2(l2), r2(r2) {}
};

struct Exam {
    int l, r;

    Exam() {}

    Exam(int l, int r) : l(l), r(r) {}

};

void solve() {
    int n, m;
    cin >> n >> m;
    /*
    vector<Exam> a(2 * n + 1);
    for (int i = 1; i <= 2 * n; ++i) {
        cin >> a[i].l >> a[i].r;
    }
    //*/
    //*
    vector<Exam2> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].l1 >> a[i].r1 >> a[i].l2 >> a[i].r2;
    }
    //*/
    vector<Exam> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].l >> b[i].r;
    }
    int ans = 0;
    for (int mask = 1; mask < (1 << m); ++mask) {
        vector<vector<bool>> can(n + 1, vector<bool> (2, true));
        int cnt = 0;
        for (int i = 0; i < m; ++i) {
            if (mask & (1 << i)) {
                ++cnt;
                for (int j = 1; j <= n; ++j) {
                    if ((a[j].l1 <= b[i].l && b[i].l <= a[j].r1) ||
                        (a[j].l1 <= b[i].r && b[i].r <= a[j].r1) ||
                        (b[i].l <= a[j].l1 && a[j].r1 <= b[i].r)) {
                        can[j][0] = false;
                    }
                    if ((a[j].l2 <= b[i].l && b[i].l <= a[j].r2) ||
                        (a[j].l2 <= b[i].r && b[i].r <= a[j].r2) ||
                        (b[i].l <= a[j].l2 && a[j].r2 <= b[i].r)) {
                        can[j][1] = false;
                    }
                }
            }
        }
        bool ok = true;
        for (int i = 1; i <= n; ++i) {
            ok &= (can[i][0] | can[i][1]);
        }
        if (ok) {
            ans = max(ans, cnt);
        }
    }
    cout << ans << en;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}