#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int n;
vector<vector<int>> g;
vector<int> used;

void ans(int v) {
    cout << "! " << v + 1 << endl;
    exit(0);
}

int ask(int v) {
    cout << v + 1 << endl;
    int x;
    cin >> x;
    if (x == 0) {
        ans(v);
        return -1;
    }
    return x - 1;
}

int dfs(int v, int p, int size, int &centroid) {
    int siz = 1;
    for (auto u: g[v]) {
        if (u != p && !used[u]) {
            siz += dfs(u, v, size, centroid);
        }
    }
    if (centroid == -1 && (2 * siz >= size || p == -1)) {
        centroid = v;
    }
    return siz;
}

void go(int v, int size) {
    int centroid = -1;
    dfs(v, -1, size, centroid);
    used[centroid] = 1;
    int u = ask(centroid);
    assert(!used[u]);
    go(u, size / 2);
}

void solve() {
    cin >> n;
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    go(0, n);
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}