#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 10'000'010;

int sieve[N];
int used[N];
int T = 0;

int get(int a, int b) {
    ++T;
    while (a != 1) {
        used[a] = T;
        a /= sieve[a];
    }
    used[a] = T;
    while (b != 1) {
        b /= sieve[b];
        if (used[b] == T) {
            return b;
        }
    }
    return 1;
}

void solve() {

    sieve[1] = 1;
    vector<int> primes;
    for (int i = 2; i < N; ++i) {
        if (sieve[i] == 0) {
            sieve[i] = i;
            primes.emplace_back(i);
        }
        for (auto j: primes) {
            if (j > sieve[i]) {
                break;
            }
            ll x = 1LL * i * j;
            if (x >= N) {
                break;
            }
            sieve[x] = j;
        }
    }

    int n;
    cin >> n;
    for (int q = 0; q < n; ++q) {
        int a, b;
        cin >> a >> b;
        int ans = max(get(a, b), get(b, a));
        if (a == b) {
            ans = a;
        }
        cout << ans << en;
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}