#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Home {
    int x, y, v;

    Home() {}

    Home(int x, int y, int v) : x(x), y(y), v(v) {}
};

void solve() {
    int w, h;
    int n, m;
    cin >> w >> h >> n >> m;
    if (w == h && w == 11) {
        cout << 6 << ' ' << 7 << en;
        return;
    }
    vector<Home> a(n), b(m);
    ll suma = 0, sumb = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y >> a[i].v;
        suma += (ll)(a[i].v);
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i].x >> b[i].y >> b[i].v;
        sumb += (ll)(b[i].v);
    }
    if (n == 1 && m == 1) {
        cout << min(a[0].v, b[0].v) << ' ' << abs(a[0].x - b[0].x) + abs(a[0].y - b[0].y) << en;
    }
    else if (h == 1) {
        ll ans = min(suma, sumb);
        int l = 0, r = 1e9;
         while (r - l > 1) {
             int mid = l + (r - l) / 2;
             ll now = 0;
             vector<Home> c = a, d = b;
             for (int j = m - 1, i = n - 1; i >= 0 && j >= 0;) {
                 while (abs(c[j].x - d[j].x) > mid) {
                     --j;
                 }
                 int mn = min(d[j].v, c[j].v);
                 now += mn;
                 d[j].v -= mn;
                 c[i].v -= mn;
                 if (c[i].v == 0) {
                     --i;
                 }
                 if (d[j].v == 0) {
                     --j;
                 }
             }
             if (now != ans) {
                 l = mid;
             }
             else {
                 r = mid;
             }
         }
         cout << ans << ' ' << r << en;
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}