#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

#pragma GCC optimize("Ofast")

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Hesh {
    int n;
    ll mod, p;
    vector<ll> h;
    vector<ll> pw;

    Hesh(ll _mod, ll _p, string &s) {
        mod = _mod;
        p = _p;
        n = sz(s);
        h.resize(n + 1);
        h[0] = 0;
        pw.resize(n + 1);
        pw[0] = 1;
        for (int i = 1; i <= n; ++i) {
            h[i] = ((h[i - 1] * p + s[i - 1]) % mod);
            pw[i] = pw[i - 1] * p % mod;
        }
    }

    ll get() {
        return h.back();
    }

};

//const ll P = 239;
const ll P = 449;
//const ll MOD = 228228227;
const ll MOD = 1e18 + 9;

void solve() {
    int n, k, len;
    string alph;
    cin >> n >> k >> len >> alph;
    unordered_map<ll, int> cnt;
    vector<string> a(n);
    unordered_map<ll, string> mapa;
    vector<unordered_set<ll>> kek(n);
    for (int i = 0; i < n; ++i) {
        string s, t;
        cin >> s;
        a[i] = s;
        Hesh h(MOD, P, s);
        ll H = h.get();
        if (cnt[H] != 0) {
            int id = cnt[H];
            kek[id - 1].erase(H);
        }
        else {
            cnt[H] = i + 1;
            kek[i].emplace(H);
        }
        mapa[H] = s;
        t = s;
        for (int j = 0; j < k; ++j) {
            for (auto c: alph) {
                if (c == t[j]) {
                    continue;
                }
                t[j] = c;
                h = Hesh(MOD, P, t);
                H = h.get();
                if (cnt[H] != 0) {
                    int id = cnt[H];
                    kek[id - 1].erase(H);
                }
                else {
                    cnt[H] = i + 1;
                    kek[i].emplace(H);
                }
                mapa[H] = t;
                t[j] = s[j];
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        ll ans = 0;
//        string sans;
//        Hesh h(MOD, P, a[i]);
//        if (cnt[h.get()] == 1) {
//            ++ans;
//            sans = a[i];
//        }
//        string t = a[i];
//        for (int j = 0; j < k; ++j) {
//            for (auto c: alph) {
//                if (c == t[j]) {
//                    continue;
//                }
//                t[j] = c;
//                h = Hesh(MOD, P, t);
//                if (cnt[h.get()] == 1) {
//                    ++ans;
//                    sans = t;
//                }
//                t[j] = a[i][j];
//            }
//        }
//        cout << ans << ' ' << sans << en;
//    }
    for (int i = 0; i < n; ++i) {
        int siz = sz(kek[i]);
        cout << siz << ' ';
        if (siz != 0) {
            cout << mapa[*kek[i].begin()];
        }
        cout << en;
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}