#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;
const int maxC = 1e6 + 9;
struct pt {
    ld x, y;
    pt operator-(const pt& sec) const {
        return pt{x - sec.x, y - sec.y};
    }
    ld operator%(const pt& sec) const {
        return x * sec.y - sec.x * y;
    }
};
vector<pt> s;


void make_conv() {
    vector<pt> st;
    for(auto &i: s) {
        while(len(st) >= 2 && (i - st.back()) % (st.back() - st[len(st) - 2]) >= 0) st.pop_back();
        st.pb(i);
    }
    s = st;
}


bool inside(pt a) {
    assert(len(s) >= 3);
    int L = 1, R = len(s) - 1;
    if((a - s[0]) % (s[1] - s[0]) > 0) return false;
    if((a - s[0]) % (s[R] - s[0]) < 0) return false;

    while(R - L > 1) {
        int M = (L + R) / 2;
        if((a - s[0]) % (s[M] - s[0]) < 0) L = M;
        else R = M;
    }

    return (a - s[L]) % (s[R] - s[L]) <= 0;
}
vector<int> divs[maxC];
void init() {
    for(int i = 2; i < maxC; ++i) {
        if(divs[i].empty()) {
            for(int j = i; j < maxC; j += i) {
                divs[j].pb(i);
            }
        }

    }
}

int get_co(int n, int r) {
    int res = 0;
//    for(int i = 1; i <= r; ++i) {
//        if(__gcd(i, n) == 1) ++res;
//    }
//    return res;
    int k = len(divs[n]);
    for(int msk = 0; msk < (1 << k); ++msk) {
        int f = 1;
        int z = 1;
        for(int j = 0; j < k; ++j) {
            if((msk >> j) & 1) {
                f *= divs[n][j];
                z *= -1;
            }
        }
        res += z * (r / f);
    }
    return res;
}

ld get_x(pt a, pt b, ld y, bool lft) {
    if(a.y == b.y) return (lft ? min(a.x, b.x) : max(a.x, b.x));
    ld spid = (b.x - a.x) / (b.y - a.y);
    return a.x + spid * (y - a.y);
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);


    init();

    int n; cin >> n;
    s.assign(n, {0, 0});
    int mny = inf, mxy = -1;
    int M = 0;
    for(auto &i: s) {
        cin >> i.x >> i.y;
        mny = min(mny, (int) ceil(i.y));
        mxy = max(mxy, (int) floor(i.y));
    }

    make_conv();

    for(int i = 0; i < n; ++i) {
        if(s[i].y < s[M].y) M = i;
    }

    ll ans = 0;
//    int Lx = s[M].x, Rx = s[M].x;
//    for(int i = mny; i <= mxy; ++i) {
//        while(Lx <= Rx && inside(pt{(ld) Lx - 1, (ld) i})) --Lx;
//        while(Lx <= Rx && !inside(pt{(ld) Lx, (ld) i})) ++Lx;
//
//        while(Lx <= Rx && inside(pt{(ld) Rx + 1, (ld) i})) ++Rx;
//        while(Lx <= Rx && !inside(pt{(ld) Rx, (ld) i})) --Rx;
//
//        ans += get_co(i, Rx) - get_co(i, Lx - 1);
//    }
    int L = (M - 1 + n) % n, R = (M + 1) % n;
    for(int i = mny; i <= mxy; ++i) {
        while(s[L].y < i) L = (L - 1 + n) % n;
        while(s[R].y < i) R = (R + 1) % n;
        int Lx = ceil(get_x(s[(L + 1) % n], s[L], i, true));
        int Rx = floor(get_x(s[(R - 1 + n) % n], s[R], i, false));
        if(Lx <= Rx) {
            ans += get_co(i, Rx) - get_co(i, Lx - 1);
        }


    }
    cout << ans << '\n';
}
/*
4
1 1
2 1
3 1
2 2

4
1 1
4 1
4 4
1 4





 */