#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <cstdlib>

using namespace std;
#define int long long
//#pragma GCC optimize("O3")

struct pt {
    int x, y;
    pt(): x(0), y(0) {}

    pt(int a, int b) : x(a), y(b) {}

    void read() { cin >> x >> y; }

    bool operator==(pt o) {
        return x == o.x && y == o.y;
    }

    pt operator+(pt o) {
        return pt(x + o.x, y + o.y);
    }

    pt operator-(pt o) {
        return pt(x - o.x, y - o.y);
    }

    int operator*(pt o) {
        return x * o.x + y * o.y;
    }

    int operator%(pt o) {
        return x * o.y - o.x * y;
    }
};

int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        if (a > b) {
            a %= b;
        }
        else {
            b %= a;
        }
    }
    return max(a, b);
}

bool checkbelong(pt a, pt b, pt c) {
    if (c == a || c == b) return true;
    pt AB = b - a;
    pt AC = c - a;
    if (AB % AC != 0) return false;
    pt BA = a - b;
    pt BC = c - b;
    return AB * AC >= 0 && BA * BC >= 0;
}

signed main() {
    int n;
    cin >> n;
    vector<pt> mnog(n);
    for (int i = 0; i < n; i++) {
        long double a, b;
        cin >> a >> b;
        mnog[i].x = (int)(a * 1000);
        mnog[i].y = (int)(b * 1000);
    }
    int maxcord = 30;
    int ans = 0;
    for (int px = 1; px <= maxcord; px++) {
        for (int py = 1; py <= maxcord; py++) {
            if (gcd(px, py) == 1) {
                pt pc(px * 1000, py * 1000);
                bool ad = true;
                for (int i = 0; i < n; i++) {
                    pt p1 = mnog[i];
                    pt p2 = mnog[(i + 1) % n];
                    if (checkbelong(p1, p2, pc)) {
                        break;
                    }
                    pt p1p2 = p2 - p1;
                    pt p1pc = pc - p1;
                    if (p1p2 % p1pc < 0) {
                        ad = false;
                        break;
                    }
                }
                if (ad) ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
