#pragma GCC optimize("O3,unroll-loops,fast-math")
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
const int INF = 1e9 + 7;
const ll LLINF = 2e18 + 13;
mt19937 rng;
uniform_int_distribution<int> uid(0, INF-1);
template<typename T>void smin(T&a,T b) {if(b<a)a=b;}
template<typename T>void smax(T&a,T b) {if(b>a)a=b;}

const int N = 2e5 + 3;
vector<int> g[N];
pair<int,int> e[N];
map<pair<int,int>,int> pte;
int sz[N];
int p[N];
bool dis[N];

int q(int v) {
  cout << v + 1 << endl;
  int a;
  cin >> a; --a;
  if (a == -1) {
    cout << "! " << v + 1 << endl;
    exit(0);
  }
  return pte[{min(v,a), max(v,a)}];
}

void dfs1(int v, int par=-1) {
  p[v] = par;
  sz[v] = 1;
  for (int edge : g[v]) {
    int u = e[edge].first ^ e[edge].second ^ v;
    if (u == par) continue;
    dfs1(u, v);
    sz[v] += sz[u];
  }
}

int centroid(int v, int n) {
  n >>= 1;
  while (true) {
    bool deep = false;
    for (int edge : g[v]) {
      int u = e[edge].first ^ e[edge].second ^ v;
      if (u == p[v] || dis[edge]) continue;
      if (sz[u] > n) {
        deep = true;
        v = u;
        break;
      }
    }
    if (!deep) break;
  }
  return v;
}

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int n;
  cin >> n;
  for (int i = 0; i < n-1; ++i) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    if (v < u) swap(u,v);
    g[u].push_back(i);
    g[v].push_back(i);
    pte[{u,v}] = i;
    e[i] = {u,v};
  }
  dfs1(0);
  bool clionFckU = true;
  int clionFckU2 = 0;
  int root = 0;
  while (clionFckU) {
    if (clionFckU2++ == 10000000) clionFckU = false;
    int v = centroid(root, n);
    int edge = q(v);
    int u = e[edge].first ^ e[edge].second ^ v;
    dis[edge] = true;
    if (u == p[v]) {
      sz[v] -= sz[u];
      n -= sz[u];
    } else {
      root = u;
      n = sz[u];
    }
  }

  return 0;
}
