#pragma GCC optimize("O3,unroll-loops,fast-math")
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <cassert>
#include <random>
using namespace std;
typedef long long ll;
const int INF = 1e9 + 7;
const ll LLINF = 2e18 + 13;
mt19937 rng;
uniform_int_distribution<int> uid(0, INF-1);
template<typename T>void smin(T&a,T b) {if(b<a)a=b;}
template<typename T>void smax(T&a,T b) {if(b>a)a=b;}

const int N = 3e5 + 3;
const int MOD = 1e9 + 9;
const int P = 911;
int pws[N];
int add(int a, int b) {
  return a + b >= MOD ? a + b - MOD : a + b;
}
int sub(int a, int b) {
  return a - b < 0 ? a - b + MOD : a - b;
}
int mul(int a, int b) {
  return 1ll * a * b % MOD;
}
int getHash(string & s) {
  int res = 0;
  for (int i = 0; i < s.size(); ++i) {
    res = add(res, mul(s[i], pws[i]));
  }
  return res;
}
int replaceChar(int hash, int pos, char prev, char now) {
  return add(sub(hash, mul(prev, pws[pos])), mul(now, pws[pos]));
}

int n, k, _alph;
char c = 18;

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  pws[0] = 1;
  for (int i = 1; i < N; ++i) pws[i] = mul(pws[i-1], P);

  cin >> n >> k >> _alph;

  map<int,int> st;
  vector<string> a(n);
  vector<int> h(n, 0);

  string alphabet;
  cin >> alphabet;

  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    h[i] = getHash(a[i]);
    for (int j = 0; j < k; ++j) {
    //int th = add(sub(h[i], mul(a[i][j], pws[j])), mul(c, pws[j]));
      int th = replaceChar(h[i], j, a[i][j], c);
      ++st[th];
    }
  }
  for (int i = 0; i < n; ++i) {
    int cnt = 0;
    bool allUnique = true;
    string example;
    for (int j = 0; j < k; ++j) {
//      int th = add(sub(h[i], mul(a[i][j], pws[j])), mul(c, pws[j]));
      int th = replaceChar(h[i], j, a[i][j], c);
      if (st[th] == 1) {
        for (char ch : alphabet) {
          if (ch == a[i][j]) continue;
          // try ch at a[i][j]
//          int nh = add(sub(h[i], mul(a[i][j], pws[j])), mul(ch, pws[j]));
          int nh = replaceChar(h[i], j, a[i][j], ch);
          bool ok = true;
          for (int l = 0; l < k; ++l) {
            if (l == j) continue;
//            if (st[add(sub(nh, mul(a[i][j], pws[l])), mul(ch, pws[l]))]) {
            if (st[replaceChar(nh, l, a[i][l], c)]) {
              ok = false;
              break;
            }
          }
          if (ok) {
            ++cnt;
            if (example.empty()) {
              example = a[i];
              example[j] = ch;
            }
          }
        }
      } else {
        allUnique = false;
      }
    }
    cnt += allUnique;
    cout << cnt;
    if (cnt) {
      assert(!example.empty());
      cout << " " << example;
    } else {
      assert(example.empty());
    }
    cout << endl;
  }

  return 0;
}
